package com.zipcodewilmington.phonebook;

import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.TreeMap;

/**
 * Created by leon on 1/23/18.
 */
public class PhoneBookTest {

    PhoneBook phoneBook;
    String name;
    String name2;
    ArrayList<String> numbers;
    ArrayList<String> numbers2;

    @Before
    public void setUp() {
    phoneBook = new PhoneBook();
    name = "Karen";
    name2 = "Joshua";
    numbers = new ArrayList<>(Arrays.asList("(302) 555-5555", "(302) 999-5555"));
    numbers2 = new ArrayList<>(Arrays.asList("(302) 333-3333", "(302) 222-2222"));
}

    @Test
    public void addTest(){
        phoneBook.add(name, numbers);
        String expected = "Karen : (302) 555-5555\n(302) 999-5555\n";
        String actual = phoneBook.getListings();
        Assert.assertEquals(expected, actual);
    }


   @Test
    public void getListingTest(){
        phoneBook.add(name, numbers);
        phoneBook.add(name2, numbers2);
        String actual = phoneBook.getListings();
        String expected = "Joshua : (302) 333-3333\n(302) 222-2222\nKaren : (302) 555-5555\n(302) 999-5555\n";

        Assert.assertEquals(expected, actual);
    }

    @Test
    public void hasEntryTest(){
        phoneBook.add(name, numbers);
        boolean actual = phoneBook.hasEntry(name);
        //then
        Assert.assertTrue(actual);
    }

    @Test
    public void lookUpTest(){
        phoneBook.add(name, numbers);
        String actual = phoneBook.lookUp(name);
        String expected = "(302) 555-5555, (302) 999-5555";
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void removeTest(){
        phoneBook.add(name, numbers);
        phoneBook.remove(name);
        boolean actual = phoneBook.hasEntry(name);
        Assert.assertFalse(actual);
    }

    @Test
    public void reverseTest(){
    phoneBook.add(name, numbers);
    String expected = "Karen";
    String actual = phoneBook.reverse("(302) 999-5555");
    Assert.assertEquals(expected, actual);
    }


}
